function LinkedList_AddItem(rootNode as LinkedNode ptr, item as any ptr)  as LinkedNode ptr
	dim node as LinkedNode ptr
	dim newNode as LinkedNode ptr
	
	newNode=MEM_ALLOC(sizeof(LinkedNode))
	newNode->Item=item
	
	if (rootNode=0) then
		newNode->NextItem=0
		newNode->PrevItem=0
		LinkedList_AddItem=newNode
	else
		node=rootNode
		while(node->NextItem <> 0)
			node=node->NextItem
		WEND
		newNode->PrevItem=node
		node->NextItem=newNode
		LinkedList_AddItem=rootNode
	end if
	
end function

sub LinkedList_RemoveItem(rootNode as LinkedNode ptr,item as any ptr)
	dim node as LinkedNode ptr
	node=rootNode
	
	while(node->NextItem<> 0 and node->Item<>item)
		node=node->NextItem
	WEND
	
	if (node->item = item) then
		if (node->PrevItem<>0) then node->PrevItem->NextItem = node->NextItem
		if (node->NextItem<>0) then node->NextItem->PrevItem = node->PrevItem
		node->PrevItem=0
		node->NextItem=0
		node->Item=0
		MEM_FREE(node)
	end if
end sub

function LinkedList_ElementAt(rootNode as LinkedNode ptr,index as integer) as any ptr
	dim node as LinkedNode ptr
	node=rootNode
	
	dim cpt as integer
	cpt=0
	while(node->NextItem<>0 and cpt<index)
		node=node->NextItem
		cpt=cpt+1
	WEND
	
	if (node<>0 and cpt=index) then
		LinkedList_ElementAt=node->Item
	else
		LinkedList_ElementAt = 0
	end if
end function

function LinkedList_IndexOf(rootNode as LinkedNode ptr,item as any ptr) as integer
	dim node as LinkedNode ptr
	node=rootNode
	
	dim cpt as integer
	cpt=0
	while(node->NextItem<>0 and node->Item<>item)
		node=node->NextItem
		cpt=cpt+1
	WEND
	
	if node->Item=item then
		LinkedList_IndexOf=cpt
	else
		LinkedList_IndexOf=-1
	end if
end function

sub LinkedList_Insert(rootNode as LinkedNode ptr,index as integer, item as any ptr)
	dim node as LinkedNode ptr
	dim newNode as LinkedNode ptr
	node=rootNode
	
	dim cpt as integer
	cpt=0
	
	while(node->NextItem<>0 and cpt<index)
		node=node->NextItem
		cpt=cpt+1
	WEND
	
	if ((cpt=index or cpt=index-1) and node <> 0) then
		newNode=MEM_ALLOC(sizeof(LinkedNode))
		newNode->Item=item
		
		if (cpt=index) then
			newNode->NextItem=node
			newNode->PrevItem=node->PrevItem
		elseif (cpt=index-1) then
			newNode->PrevItem=node
			newNode->NextItem=node->NextItem
		end if
		if (newNode->PrevItem<>0) then newNode->PrevItem->NextItem=newNode
		if (newNode->NextItem<>0) then newNode->NextItem->PrevItem=newNode
	end if
end sub

sub LinkedList_ForEach(rootNode as LinkedNode ptr, action as sub(item as any ptr) ptr)
	dim node as LinkedNode ptr
	node = rootNode
	while(node <> 0)
		(*action)(node->Item)
		node=node->NextItem
	wend
end sub