declare sub VmRuntime_Init()
declare sub VmRunTime_MainLoop()
declare sub VmRunTime_ForeachThread(theThread as VmThread ptr)
declare sub VmRuntime_Run(threadHandle as unsigned integer,instruction as VmInstructionBlock,regs as RegistersMemory,appMem as byte ptr, stackMem as StackMemory ptr)


declare sub Handle_NOP (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_MOV (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_CLE (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_CLA (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_CLB (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_CLZ (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SLE (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SLA (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SLB (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SLZ (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_ITOS (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_STOI (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_ADD (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_FADD (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SUB (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_FSUB (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_MUL (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_FMUL (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_DIV (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_FDIV (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_INC (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_FINC (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_DEC (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_FDEC (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_LOOP (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JMP (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JE (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JNE (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JA (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JNA (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JAE (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_JNAE (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_AND (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_OR (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_XOR (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_NEG (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_NOT (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SHL (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_SHR (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_PUSH (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_POP (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_PUSHF (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_POPF (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_PUSHA (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_POPA (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_CALL (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_XCALL (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_RET (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_CMP (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_INT (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_HLT (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
declare sub Handle_LMOD (threadHandle as unsigned integer,instruction as VmInstructionBlock, regs as RegistersMemory, appMem as byte ptr, stackMem as StackMemory ptr)
