TYPE StackMemory
	StackPointer as unsigned integer
	StackSize as unsigned Integer
	Store as byte ptr
end Type

declare function StackMemory_Create(storeSize as unsigned integer) as StackMemory ptr
declare sub StackMemory_Destroy(theStack as StackMemory ptr)

declare sub StackMemory_Push32(theStack as StackMemory ptr,theVal as Integer)
declare function StackMemory_Pop32(theStack as StackMemory ptr) as integer
declare sub StackMemory_Push16(theStack as StackMemory ptr,theVal as short)
declare function StackMemory_Pop16(theStack as StackMemory ptr) as short
declare sub StackMemory_Push8(theStack as StackMemory ptr,theVal as byte)
declare function StackMemory_Pop8(theStack as StackMemory ptr) as byte
declare function StackMemory_Get32(theStack as StackMemory ptr,index as unsigned integer) as integer
declare function StackMemory_Get16(theStack as StackMemory ptr,index as unsigned integer) as short
declare function StackMemory_Get8(theStack as StackMemory ptr,index as unsigned integer) as byte
declare sub StackMemory_Set32(theStack as StackMemory ptr, theVal as integer, index as unsigned integer)
declare sub StackMemory_Set16(theStack as StackMemory ptr, theVal as short, index as unsigned integer)
declare sub StackMemory_Set8(theStack as StackMemory ptr, theVal as byte, index as unsigned integer)