#include Once "../../Include/Vm/VmProcess.bi"

function VmProcess_Create(bdata as byte ptr) as VmProcess ptr
	dim retval as VmProcess ptr
	retval = MEM_ALLOC(sizeof(VmProcess))
	retval->Threads=0
	retval->MemoryData = bdata
	retval->Instructions = cptr(VmInstructionBlock ptr,bdata)
	
	dim header as Unsigned integer ptr
	header=cptr(Unsigned integer ptr,bdata)
	retval->magic = header[0]
	retval->MainEntryPoint = header[1]
	retval->RedrawEntryPoint = header[2]
	retval->OnEventEntryPoint = header[3]
	retval->OnErrorEntryPoint = header[4]
	
	dim firstThread as VmThread ptr
	firstThread = VmThread_Create(retval)
	firstThread->ThreadRegs.EIP= retval->MainEntryPoint
	
	VmProcess_Create = retval
end function
